 @echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
    
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	rem 0123456789a123
	rem Tue 10/18/2011
	rem 10/18/2011

	call "!bat_exedir!\localize_GETDATE2_!bat_AUTOCAMS.locale!.bat"
	set bat_curdate=!bat_currdate!&	rem set bat_curdate=%date:~-10%
	if "%~1" neq "" (
		set bat_curdate=%~1
	)

	set bat_curdate=!bat_curdate:~-10!
	
	echo.%bat_curdate%|find /i "/">nul:
	if %errorlevel% equ 0 (
		rem echo for /f "delims=/ tokens=1-3" %%a in ^("!bat_curdate!"^) do ...
		for /f "delims=/ tokens=1-3" %%a in ("!bat_curdate!") do (
			rem echo %%a/%%b/%%c
			set bat_curm=0%%a
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%b
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%c
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	) else (
		rem echo for /f "delims=_ tokens=1-3" %%a in ^("!bat_curdate!"^) do ,,,
		for /f "delims=_ tokens=1-3" %%a in ("!bat_curdate!") do (
			rem echo %%a/%%b/%%c
			set bat_curm=0%%a
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%b
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%c
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	)

:SETUP2	
	set bat_date=!bat_cury:~-4!_!bat_curm:~-2!_!bat_curd:~-2!
	set bat_curdate=!bat_curm:~-2!/!bat_curd:~-2!/!bat_cury:~-4!
	rem set bat_datemin=!bat_year:~-4!!bat_mo:~-2!!bat_da:~-2!


	rem set bat_curm=!bat_curdate:~-2!
	rem set bat_curd=!bat_curdate:~-2!
	rem set bat_cury=!bat_cury:~-4!
	rem set bat_cury=!bat_cury:~-4!
	set /a bat_prevy=!bat_cury!-1
	
	set bat_sunsettable=%~dp0twilight.csv.txt
	
:DAYOFWEEK
	call :date2jdate bat_JD !bat_cury! !bat_curm! !bat_curd!
	call :jdate2date !bat_JD! bat_yyyy bat_mm bat_dd
	set /a bat_wdayn=((!bat_JD!*100)/7)-(!bat_JD!/7*100)
	if !bat_wdayn! equ 85 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 0 (
			set bat_weekday=Monday
		) else (
			if !bat_wdayn! equ 14 (
				set bat_weekday=Tuesday
			) else (
				if !bat_wdayn! equ 28 (
					set bat_weekday=Wednesday
				) else (
					if !bat_wdayn! equ 42 (
						set bat_weekday=Thursday
					) else (
						if !bat_wdayn! equ 57 (
							set bat_weekday=Friday
						) else (
							if !bat_wdayn! equ 71 (
								set bat_weekday=Saturday
							)
						)
					)
				)
			)
		)
	)

	rem echo !bat_curdate!, !bat_yyyy!/!bat_mm!/!bat_dd!, JD=!bat_jd!, !bat_wdayn!, !bat_weekday!

	
	echo %~0 %*
	echo.
	echo Usage: %~0 mm/dd/yyyy   - Checking sunset table for !bat_curdate!
	echo.
goto :MAIN

:MAIN
	find /i "!bat_curm!/!bat_curd!/!bat_cury!" "!bat_sunsettable!">nul:
	if !errorlevel! neq 0 goto :ERR1

	echo   find /i "Delay will be from the earliest" "!bat_sunsettable!"
	for /f "usebackq tokens=1-2* delims=," %%a in (`find /i "TaskScheduler" "!bat_sunsettable!"`) do (
		set bat_scheduledstarttime=%%a
	)
	echo 	Task Scheduler Start Time (Wall timer ON)=!bat_scheduledstarttime!
	echo.

	echo   find /i "Latest wall timer hour" "!bat_sunsettable!"
	for /f "usebackq tokens=1-5* delims=," %%a in (`find /i "Wall Timer OFF" "!bat_sunsettable!"^`) do (
		set bat_walltimeroff=%%a
	)
	echo 	Task Scheduler Stop Time (Wall timer OFF)=!bat_walltimeroff!
	echo.

	for /f "usebackq tokens=1-5 delims=, skip=1" %%a in (`find /i "dawn off offset" "!bat_sunsettable!"`) do (
		set bat_sa_off=%%d
		set bat_sunangleoff=           %%d
		set bat_sunangleoff=!bat_sunangleoff:~-7!
	)

	for /f "usebackq tokens=1-5 delims=, skip=1" %%a in (`find /i "dusk on offset" "!bat_sunsettable!"`) do (
		set bat_sa_on=%%d
		set bat_sunangleon=            %%d
		set bat_sunangleon=!bat_sunangleon:~-7!
	)

	echo            	         	         	    	   	   	Dusk   	Dusk     	Dawn						
	echo            	         	         	    	   	   	(UTC at	(LDT at   	(UTC at						
	echo            	Dawn OFF	Dusk ON  	Dur-	    	     	!bat_sa_on! below	!bat_sa_on! below   	!bat_sa_off! below						
	echo   Date    	8o       	8o       	ation	Delay  	DST	horizon	horizon   	horizon   	date    	sunrise	sunset  	Day #
	echo   ====    	======== 	=======  	=====	=====  	===========	=======   	=======   	======= 	=======	======= 	=====
	for /f "usebackq tokens=1-16 delims=," %%a in (`find /i "!bat_curm!/!bat_curd!/!bat_cury!" "!bat_sunsettable!"^|find /i /v "!bat_sunsettable!"`) do (
		echo   %%a    %%b        %%c        %%d   %%e    %%f       %%g %%h      %%i        %%j        %%k %%l      %%m
	)
	rem find /i "!bat_curm!/!bat_curd!/!bat_cury!" "sunsettable.txt"|find /i /v "!bat_sunsettable!"
	echo.
	echo   for /f "usebackq tokens=1-16 skip=2 delims=," %%%a in ^(`find /i "!bat_curm!/!bat_curd!/!bat_cury!" "!bat_sunsettable!"`^) do ...
	for        /f "usebackq tokens=1-16 skip=2 delims=," %%a in (`find /i "!bat_curm!/!bat_curd!/!bat_cury!" "!bat_sunsettable!"`) do (
	echo.
		if "%%a" neq "----------" (
			echo    Date=               %%a  - Date of these calculations ^(!bat_weekday!^)
			call :CALCDAYNUMBER %%m
			echo    Day number=         !bat_res3!         - Day of the year 
			echo    Task Sched Start    !bat_scheduledstarttime!    - Local time Windows Task Scheduler is supposed to launch this script
			echo    Current Time        !time:~0,8!    - Current local time
			echo.
			echo    Sunset Local=       %%l  - Local sunset time
			echo    Camera ON Local     %%h  - Local time of the first frames, Use this to set our wall timer.
			echo    Camera ON=          %%c    - Local time Task Scheduler should start capture
			echo    Camera ON UTC       %%g     - UTC time ^(camera time^) of the first frame
			echo    Camera ON sun angle !bat_sunangleon!     - degrees below horizon
			echo.
			echo    Camera OFF UTC       %%i   - UTC time ^(camera time^) of the last frame
			echo    Camera OFF Local=    %%b   - Local time capture should end in the morning
			echo    Sunrise Local=       %%k    - Local sunrise time ^(next morning^)
			echo    Camera OFF sun angle!bat_sunangleoff!     - degrees below horizon
			echo.
		for /f "tokens=1,2 delims=." %%x in ("%%d") do (

			set /a bat_h=%%x
			set /a bat_d=%%y
			call :STRIPZEROS %%x bat_h
			call :STRIPZEROS %%y bat_d
			set bat_d=!bat_d!00
			set bat_d=!bat_d:~0,2!
			
			set /a bat_durtotalsecs=!bat_h!*3600 + !bat_d!*36
		)

			echo    Duration=            %%d      - Number of hours to capture ^(24:00:00 - ON + OFF^)
			echo    Delay=               %%e       - Number of seconds to delay from the scheduled start time ^(!bat_scheduledstartime!^)
			echo    DST=                 %%f          - 1 if this date uses DST.  0 if not
			echo                                      Note: Dawn is calculated for the next morning
			set /a bat_estCapFiles=!bat_durtotalsecs!0000 / 85333
			set /a bat_estSizeMB=!bat_estCapFiles!*11723 / 10000
			set /a bat_reqdisk=!bat_estSizeMB!*!bat_AUTOCAMS.diskspacewarning.days!*!bat_CAPTURE.number.of.cameras!

			call "str_math.bat" -command "[math]::round(!bat_estSizeMB! / 1024,3)">nul:
			echo    Disk space required per night per camera=!bat_retval! GB
			echo    Disk space warning days=!bat_AUTOCAMS.diskspacewarning.days!
			call "str_math.bat" -command "[math]::round(!bat_reqdisk! / 1024,3)">nul:
			echo    Estimated space requirements for the next !bat_AUTOCAMS.diskspacewarning.days! nights is roughly: !bat_retval! GB
			echo.
			echo    To check how much disk space you will require over the next !bat_AUTOCAMS.diskspacewarning.days! days, 
			echo    execute this command:
			echo        call "!bat_exedir!\checkfreespace.bat" !bat_exedrive! !bat_durtotalsecs!
			echo.
			echo        [Note: See the AutoCams.Params.ini file to adjust these warnings:
			echo           [AUTOCAMS]
			echo           diskspacewarning.days=!bat_AUTOCAMS.diskspacewarning.days!
			echo.
		)
	)
goto :DONE

:CALCDAYNUMBER
	rem Usage: call :CALCDAYNUMBER day
	rem   where day is the day number from the sunsettable.txt file.  In that file,
	rem   the day number in in the file for the first date (01/01/2011) has a value
	rem   of zero.  It should be reported as day 1 and 12/31/2011 is 365 and
	rem   01/01/2012 is day 365, which should be reported as day 1 of year 2012. 
	rem   The only thing that should be an issue between different people using this
	rem   is the bat_offset number below (109600), which may need to be adjusted 
	rem   depending how how many days of offset from a daylight savings date
	rem   is used as the base date.  
	rem
	rem   The 109600 number is essentially 1096.00, which represents 3 years
	rem   before. This algorithm is based on knowning that the 1st day of the 
	rem   year 3 years before is a known day of the week.
	
	set /a bat_day=%1*100
	set /a bat_offset=109600
	set /a bat_year=36525
	
	set /a bat_divide=(((!bat_day!+!bat_offset!)*10000)/!bat_year!)
	set /a bat_int=((!bat_day!+!bat_offset!)/36525)
	set /a bat_mod=!bat_divide!-(!bat_int!*10000)
	set /a bat_res1=!bat_mod!*36525
	set /a bat_res2=!bat_res1!+100000
	set /a bat_res3=(!bat_res2!/1000000)+1
	set bat_res3=!bat_res3!   
	set bat_res3=!bat_res3:~0,3!
goto :EOF

:ERR1
	echo.
	echo ERROR - Date not found: "!bat_curm!/!bat_curd!/!bat_cury!"
	echo.
goto :DONE

:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
EXIT /b




:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
call "!bat_exedir!\Date2JDate.bat"
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat"
EXIT /b 0




:HELP
	echo %~nx0
	echo.
	echo  Usage: %~nx0 [date]
	echo.
	echo  Where:
	echo.
	echo   date		Is optional.  If you use the date argugment, it must be
	echo       		in the format of the US dates (yyyy/mm/dd).  If you omit
	echo       		the date argument, it assumes the current date from the 
	echo       		computer's %%date%% environment variable. 
	echo.
	echo  Examples:
	echo.
	echo   CheckTwilight
	echo      Will produce the report for the current date.
	echo.
	echo   CheckTwilight 12/31/2011
	echo      Will produce the report for December 31, 2011
	echo.
	echo  This script presents a report on the dusk/dawn information based on
	echo  the "twilight.csv.txt".  
	echo.
	echo  The "twilight.csv.txt" file should be customized for each site or 
	echo  area. Complete instructions can be found in the Cams.PDF documentation. 
	echo  In general, the file is customized using the the following steps:
	echo    1^) Use Microsoft Excel 2007 or 2010 for the "twilight.xlsm" file
	echo    2^) Edit the fields in yellow to match the values for your station
	echo    3^) File ^> Save As...
	echo    4^) Select "CSV ^(Comma delimted^) ^(*.csv^)"
	echo    5^) Name the file as "twilight.csv"
	echo    6^) Close Excel
	echo    7^) In the AutoCams.Params.ini file [CAPTURE] section, set the 
	echo        bat_sunsettablename= value to the name of the output CSV file. 
	echo    8^) Rename the output file "twilight.csv" to "twilight.csv.txt"
	echo    9^) Run CheckTwilight.bat and look for errors in the report
	echo.
	echo  The script displays the entry that contains the specified
	echo  date in table form.  Then it provides an intepreted report
	echo  in list form.  
exit /b

	
:DONE