@echo off

:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
setlocal
        rem                        -- JD   [out] - julian days
        rem                        -- YYYY [in]  - gregorian year, i.e. 2006
        rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
        rem                        -- DD   [in]  - gregorian day, i.e. 31
        rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
        rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
        rem :$source http://www.dostips.com
        set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
        set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
        if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
        set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4

ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b 0

