@echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
    
    set bat_batchfile=%~f0

    set bat_tempfile=%~dpn0.txt

    set bat_savecmdline=%*
    set bat_verbose=false
    set bat_format=false
    rem set bat_formatstr=/format:"%windir%\system32\wbem\en-us\csv.xsl"
    set bat_remote=false
    set bat_remotemachine=error
    
:CMDSWITCHES
	
	set bat_verbose=true
	echo.%*|find /i "/nocommas">nul:
	if %errorlevel% equ 0 (
		set bat_verbose=false
	)
	
:CMDSWLOOP	
	if "%~1" equ "" goto :CMDSWEND
	
	if /i "%~1" equ "/remote" (
		if "%2" equ "" goto :HELP
		set bat_remote=true
		set bat_remotemachine=%~2
		shift
	) else (
		echo.%1|find /i "/format:">nul:
		if %errorlevel% equ 0 (
			set bat_format=true
			set bat_formatstr=%1
		)
	)
	shift
	goto :CMDSWLOOP
:CMDSWEND


:MAIN
	if !bat_remote! equ true (
		echo Remote Computer: !bat_remotemachine!
		
		wmic /Node:"%bat_remotemachine%" logicaldisk get deviceid, caption, description, volumename, filesystem, size, freespace, drivetype %bat_formatstr%>"!bat_tempfile!"
		set /a bat_linenumber=0
		for /f "usebackq tokens=1-15 delims=," %%a in (`type "!bat_tempfile!"`) do (
			set /a bat_linenumber+=1
			
			set bat_node=%%a
			set bat_caption=%%b         
			set bat_caption=!bat_caption:~0,9!
			set bat_desc=%%c                         
			set bat_desc=!bat_desc:~0,25!
			set bat_deviceid=%%d          
			set bat_deviceid=!bat_deviceid:~0,10!
			set bat_drivetype=%%e            
			set bat_drivetype=!bat_drivetype:~0,11!
			set bat_filesystem=%%f            
			set bat_filesystem=!bat_filesystem:~0,12!
			set bat_freespace=                  %%g
			set bat_freespace=!bat_freespace:~-18!
			set bat_size=                  %%h
			set bat_size=!bat_size:~-18!
			set bat_volumename=%%i                    
			set bat_volumename=!bat_volumename:~0,19!
			
			if /i "true" equ "!bat_verbose!" (
				call :COMMAS bat_size !bat_size!
				call :COMMAS bat_freespace !bat_freespace!
			)

			echo !bat_caption! !bat_filesystem! !bat_volumename! !bat_desc!!bat_size!  !bat_freespace!
		)
		echo.
		echo wmic /Node:"%bat_remotemachine%" logicaldisk get deviceid, caption, description, volumename, filesystem, size, freespace, drivetype /format:table
	) else (
		echo Computer: !computername!
		
		wmic logicaldisk get deviceid, caption, description, volumename, filesystem, size, freespace, drivetype !bat_formatstr!>"!bat_tempfile!"
		set /a bat_linenumber=0
		
		for /f "usebackq tokens=1-15 delims=," %%a in (`type !bat_tempfile!`) do (
			set /a bat_linenumber+=1

			
			set bat_node=%%a
			set bat_caption=%%b         
			set bat_caption=!bat_caption:~0,9!
			set bat_desc=%%c                         
			set bat_desc=!bat_desc:~0,25!
			set bat_deviceid=%%d          
			set bat_deviceid=!bat_deviceid:~0,10!
			set bat_drivetype=%%e            
			set bat_drivetype=!bat_drivetype:~0,11!
			set bat_filesystem=%%f            
			set bat_filesystem=!bat_filesystem:~0,12!
			set bat_freespace=                  %%g
			set bat_freespace=!bat_freespace:~-18!
			set bat_size=                  %%h
			set bat_size=!bat_size:~-18!
			set bat_volumename=%%i                    
			set bat_volumename=!bat_volumename:~0,19!
			
			if /i "true" equ "!bat_verbose!" (
				call :COMMAS bat_size !bat_size!
				call :COMMAS bat_freespace !bat_freespace!
			)

			echo !bat_caption! !bat_filesystem! !bat_volumename! !bat_desc!!bat_size!  !bat_freespace!
		)
		echo.
		echo wmic logicaldisk get deviceid, caption, description, volumename, filesystem, size, freespace, drivetype /format:table
	)
	
	if exist "!bat_tempfile!" (
		if defined bat_tempfile (
			del "!bat_tempfile!"
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:MAIN] Dangerous command: del "!bat_tempfile!"
		)
	)
goto :DONE

:COMMAS
	if !bat_linenumber! lss 2 goto :EOF
	if "" equ "%~2" goto :EOF
	set bat_temp2=
	set bat_temp=%~2
	set /a bat_length=0
	for /l %%m in (0,1,16) do (
		if "" equ "!bat_temp:~%%m,1" (
			rem
		) else (
			if " " equ "!bat_temp:~!%%m,1" (
				rem
			) else (
				set /a bat_length+=1
				set bat_temp2=!bat_temp2!!bat_temp:~%%m,1!
			)
		)
	)

	rem echo [!bat_temp!] [!bat_temp2!]
	set bat_temp=!bat_temp2!

	set bat_hundreds=   
	set bat_thousands=    
	set bat_millions=    
	set bat_billions=    
	set bat_trillions=    


	if "" neq "!bat_temp!" (
		rem echo bat_temp="!bat_temp!", "!bat_temp:~-3!", "!bat_temp:~0,-3!"
		set bat_hundreds=!bat_temp:~-3!
		set bat_commas=!bat_hundreds!
		set bat_temp=!bat_temp:~0,-3!
	)
	rem echo       bat_commas="!bat_commas!"

	if "" neq "!bat_temp!" (
		rem echo bat_temp=!bat_temp!, !bat_temp:~-3!, !bat_temp:~0,-3!
		set bat_thousands=!bat_temp:~-3!
		set bat_commas=!bat_thousands!,!bat_commas!
		set bat_temp=!bat_temp:~0,-3!
	)
	rem echo       bat_commas="!bat_commas!"

	if "" neq "!bat_temp!" (
		rem echo bat_temp=!bat_temp!, !bat_temp:~-3!, !bat_temp:~0,-3!
		set bat_millions=!bat_temp:~-3!
		set bat_commas=!bat_millions!,!bat_commas!
		set bat_temp=!bat_temp:~0,-3!
	)
	rem echo       bat_commas="!bat_commas!"

	if "" neq "!bat_temp!" (
		rem echo bat_temp=!bat_temp!, !bat_temp:~-3!, !bat_temp:~0,-3!
		set bat_billions=!bat_temp:~-3!
		set bat_commas=!bat_billions!,!bat_commas!
		set bat_temp=!bat_temp:~0,-3!
	)
	rem echo       bat_commas="!bat_commas!"

	if "" neq "!bat_temp!" (
		rem echo bat_temp=!bat_temp!, !bat_temp:~-3!, !bat_temp:~0,-3!
		set bat_trillions=!bat_temp:~-3!
		set bat_commas=!bat_trillions!,!bat_commas!
		set bat_temp=!bat_temp:~0,-3!
	)
	set bat_commas=                     !bat_commas!
	set bat_commas=!bat_commas:~-18!
	rem echo       bat_commas="!bat_commas!"
	set %~1=!bat_commas!
	rem echo       %~1="!bat_commas!"

goto :DONE


:PARSE
goto :EOF


	REM Loop through each of the drives and format the FreeSpace and Size
	REM values as TB, GB, MB, KB,
:VERBOSE
	echo /VERBOSE is not yet implemented
goto :DONE

:HELP
	echo     %~nx0		&rem batch file name
	echo.
	echo     Usage: %~nx0 [/remote machinename] [/nocommas] [/format:^<format specifier^>]
	echo.
	echo     Where:       machinename        Is the computername of a remote comptuer
	echo                  /nocommas          Lists the drive size information without commas
	echo                  /format...         Uses the WMIC LogicalDisk format syntax for different output
	echo                                     I like TABLE, CSV, LIST, HTABLE, and HLIST
	echo.
	echo.
	echo     WMIC LogicalDisk /format /?
	echo         /FORMAT:^<format specifier^>
	echo         NOTE: ^<formatspecifier^> : ^(^(^<transformname^>^|^<transformname^> : ^<paramstring^>^)[,^<formatspecifier^>]^).
	echo         where ^<paramstring^>:^(^(^<parametername^>=^<value^>^)[:^<paramstring^>]^).
	echo.
	echo         NOTE: ^<transformname^> is a ^<key word^> or an ^<xsl file name^>.
	echo.
	echo         Keywords:
	echo.
	echo         CSV
	echo         HFORM
	echo         HTABLE
	echo         LIST
	echo         MOF
	echo         RAWXML
	echo         TABLE
	echo         VALUE
	echo         XML
	echo         htable-sortby
	echo         htable-sortby.xsl
	echo         texttablewsys
	echo         texttablewsys.xsl
	echo         wmiclimofformat
	echo         wmiclimofformat.xsl
	echo         wmiclitableformat.xsl
	echo         wmiclitableformatnosys
	echo         wmiclitableformatnosys.xsl
	echo         wmiclivalueformat
	echo         wmiclivalueformat.xsl

goto :DONE

:DONE
