
   @echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~f0"
	call "%~dp0indent_setup.bat"
	if not defined bat_COMMENT_BEGIN (
		set bat_pushstring=

	)
	
	if not defined bat_AUTOCAMS.locale (
		!bat_logexeclog! call "!bat_exedir!\ReadParams.bat"
	)

:MAIN
	call :PARSETIME

	ENDLOCAL & (
		SET ftp_hhmmssdd=%ftp_hhmmssdd%
		set ftp_hr=%ftp_hr%
		set ftp_mi=%ftp_mi%
		set ftp_se=%ftp_se%
		set ftp_sed=%ftp_sed%
		set ftp_jd=%ftp_JD%
		set ftp_hhmmssdd_local=%ftp_hhmmssdd_local%
	)

exit /b 0



   rem When run at 10:57:13.52 PM on 10/05/2013, it should result in:
   rem    ftp_hhmmssdd=22:57:13.52
   rem    ftp_hhmmssdd_local=10:57:13.52 PM
   rem    ftp_hr=22
   rem    ftp_mi=57
   rem    ftp_se=13
   rem    ftp_sed=52
   rem    ftp_jd=2456413
:PARSETIME
!bat_pushlog! [CALL !bat_batchfile!:PARSETIME] %*
	set ftp_hhmmssdd=
	set ftp_hhmmssdd_local=
	set ftp_hr=
	set ftp_mi=
	set ftp_se=
	set ftp_sed=
	set ftp_jd=

	REM LOCALIZE STARTING HERE
	set ftp_hhmmssdd=!time!
	
	set ftp_hr=!ftp_hhmmssdd:~0,2!
	set ftp_hr=!ftp_hr: =!
	set ftp_hr=00!ftp_hr!
	set ftp_hr=!ftp_hr:~-2!

	set ftp_mi=%ftp_hhmmssdd:~3,2%
	set ftp_se=%ftp_hhmmssdd:~6,2%
	set ftp_sed=%ftp_hhmmssdd:~-2%
	set ftp_hhmmssdd=!ftp_hr!:!ftp_mi!:!ftp_se!.!ftp_sed!

	!bat_log! call "!bat_exedir!\localize_PARSEDATE1_!bat_AUTOCAMS.locale!.bat!"
	          call "!bat_exedir!\localize_PARSEDATE1_!bat_AUTOCAMS.locale!.bat!"
	!bat_log! call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	          call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	set /a bat_midnightsecs=86400
	
	if !ftp_hr! GTR 12 (
		set /a ftp_temp=ftp_hr-12
		set ftp_hhmmssdd_local=!ftp_temp!:!ftp_mi!:!ftp_se!.!ftp_sed! PM
	) else (
		set ftp_hhmmssdd_local=!ftp_hhmmssdd!.!ftp_sed! AM
	)

:PARSETIME_END
!bat_poplog! [RETURN !bat_batchfile!:PARSETIME] [ftp_hhmmssdd=!ftp_hhmmssdd!, ftp_hr=!ftp_hr!, ftp_mi=!ftp_mi!, ftp_se=!ftp_se!, ftp_jd=!ftp_jd!, ftp_hhmmssdd_local=!ftp_hhmmssdd_local!]
!bat_log!
!bat_return!



:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
call "!bat_exedir!\Date2JDate.bat"
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat"
EXIT /b 0




:HELP
	echo.Usage: call "bat_exedir\localize_PARSETIME1_en-US.bat"
	echo.
	echo.Returns:
	echo.  environment variables: ftp_hhmmssdd, ftp_hr, ftp_mi, ftp_se, ftp_jd
	echo.
	echo.The returned time "en-US" locale format where
	echo.the local time is returned as: hh:mm:ss
	echo.
	echo.Example:
	echo.  If the time is 10:39:57.956 AM on October 5, 2013, this routine should result with:
	echo.    ftp_hhmmssdd=07:15:22
	echo.    ftp_hr=07
	echo.    ftp_mi=15
	echo.    ftp_se=22
	echo.    ftp_jd=2456262      // Julian date
	echo.
	echo.This is the "en-US" local version of this script and it will serve
	echo.as a template for others to develop localized versions of this script.
	echo.
	echo.The trick is in the construct of the ENDLOCAL command, where it passes
	echo.back variables that are local to this routine.
	echo.









