rem @echo off
setlocal enabledelayedexpansion enableextensions

rem RENAME THIS FILE TO move.archived.bat and store it in the C:\CAMS directory.
rem
rem This script can be run stand-alone (before reprocessing) or called from within
rem the ftp_reprocess.bat script.

:SETUP
	setlocal enableextensions enabledelayedexpansion

    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"


	set move_targetlocation=%cd%
	set move_targetdrive=%cd:~0,2%
	set move_

:MAIN
	rem start the execution of the detection pass in background priority

	echo !date! !time!>"Logs\move.archived.log"

	rem move /Y c:\cams\archivedfiles .\ArchivedFiles

	call :CHECK
	if !errorlevel! neq 0 goto :DONE

	for /f "usebackq tokens=*" %%a in (`dir "c:\cams\archivedfiles" /s/b /ad /on`) do (
		echo %%a
		set move_srcdirfull=%%a
		set move_dirname=%%~nxa
		set move_targetdirfull="%~dp0ArchivedFiles\!move_dirname!"

		echo md "%~dp0ArchivedFiles\!move_dirname!"
		     md "%~dp0ArchivedFiles\!move_dirname!"

		echo move /Y "%%a\*.*" "%~dp0ArchivedFiles\!move_dirname!"
		     move /Y "%%a\*.*" "%~dp0ArchivedFiles\!move_dirname!"

		ECHO RD /s /q "%%a"
		     RD /s /q "%%a"

	)
:MAIN2
	for /f "usebackq tokens=*" %%a in (`type "!move_targetdirfull!\ftpdetectinfo.txt"`) do (
		set move_inputline=%%a
		set move_outputline=!move_inputline:C:=%move_targetdrive%!
		if "!move_inputline!" neq "!move_outputline!" (
			echo !move_inputline!
			echo !move_outputline!
			echo.
			echo.
		)

		title !move_outputline!
		echo !move_outputline!>>"%~dp0ArchivedFiles\!move_dirname!\FTPdetectinfo.test.txt"

	)
	copy /Y "%~dp0ArchivedFiles\!move_dirname!\FTPdetectinfo.test.txt" "%~dp0ArchivedFiles\!move_dirname!\FTPdetectinfo.txt"
	
	if defined move_dirname (
		!bat_logexec! del /q "%~dp0ArchivedFiles\!move_dirname!\FTPdetectinfo.test.txt"
	) else (
		!bat_echolog! ERROR [!bat_batchfile!:MAIN2] Dangerous command: del /q "%~dp0ArchivedFiles\!move_dirname!\FTPdetectinfo.test.txt"
	)

exit/b 0

:CHECK
	rem check if the source directories exist.
	if not exist "c:\cams" goto :HELP
	if not exist "c:\cams\archivedfiles" goto :HELP
	dir "c:\cams\ArchivedFiles" /s/b>junk.txt
	for /f "tokens=*" %%x in ("junk.txt") do (
		if "%%~zx" equ "0" (
			exit /b 0
		) 
	)
exit /b 1


	call "!bat_exedir!\localize_PARSEDATE1_!bat_AUTOCAMS.locale!.bat"
	call "!bat_exedir!\localize_PARSETIME1_!bat_AUTOCAMS.locale!.bat"

	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%


	for /f "usebackq tokens=*" %%a in (`dir ".\CapturedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_captureddir=%%~nxa
	)

	set ftp_

	for /f "usebackq tokens=*" %%a in (`dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_archiveddir=%%~nxa
	)

	set ftp_

	if defined ftp_archiveddir (
		dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad>"Logs\ftp_reprocess.log"
		dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad
		goto :ERR1
	)

:SRCHDRIVEC
	for /f "usebackq tokens=*" %%a in (`dir "c:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_archiveddir=%%~nxa
	)

	set ftp_

	if defined ftp_archiveddir (
		dir "C:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad>"Logs\ftp_reprocess.log"
		dir "C:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad
		goto :ERR1
	)

:CONTINUE


	@echo start "FTP_Reprocess" /low ".\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%">>"Logs\ftp_reprocess.log"
	echo start "FTP_Reprocess" /low ".\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%"
goto :DONE

:ERR1
	@echo.
	@echo.
	@echo "%cd%\ArchivedFiles\%ftp_archiveddir%" already exists. Do you want to
	@echo continue to overwrite the existing files? [Y/N] Y
	@goto :CONTINUE
	@set /p retval=continue to overwrite the existing files? [Y/N] 
	@if /i "%retval%" equ "y" goto :CONTINUE
goto :DONE


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
call "!bat_exedir!\Date2JDate.bat"
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat"
EXIT /b 0



:HELP
	@echo off
	echo.
	echo %0
	echo.
	echo This script can be called either stand-alone or from within
	echo ftp_reprocess.bat script.  The purpose of the script is to
	echo move the FTPdetectinfo.txt file from C:\CAMS\ArchivedFiles...
	echo directory to the local .\ArchivedFiles\... directory.
	echo.
	echo It moves the c:\cams\ArchivedFiles\... directory to the
	echo local .\ArchivedFiles\... directory.  Then it patches the 
	echo FTPdetectinfo.txt file so that the drive letters for FF and CAL
	echo are correct. 
	echo.
	echo
exit /b 9


:DONE
